Array.prototype.inArray = function(value) {
	var i;
	for(i=0; i < this.length; i++) {
		if(this[i] === value) {
			return true;
		}
	}
	return false;
};

function replace(string,text,by) {
    var strLength = string.length, txtLength = text.length;
    if ((strLength == 0) || (txtLength == 0)) return string;

    var i = string.indexOf(text);
    if ((!i) && (text != string.substring(0,txtLength))) return string;
    if (i == -1) return string;

    var newstr = string.substring(0,i) + by;

    if (i+txtLength < strLength)
        newstr += replace(string.substring(i+txtLength,strLength),text,by);

    return newstr;
}

function isNumeric(str) {
    return str.length ? !isNaN(str/1) : false
}

var timeout = null;

function startSearch() {
	var enteredNumberOrg = document.getElementById("number").value;
	if(enteredNumberOrg != "" && enteredNumberOrg != "Type Skype Name or phone number...") {
        var character = enteredNumberOrg.charAt(0);
        if(isNumeric(character) && isCollapsed == true) {
            var event = false;
            toggleView(event);
        } else {
        }
    }
    
    
	var selectedCountry = document.getElementById("country").value;
	if(selectedCountry != "") {
		if(timeout){ window.clearTimeout(timeout); }
		timeout = window.setTimeout("doSearch()",500);
	}
}

function selectCountry() {
	var selectedCountry = document.getElementById("country").value;
	if(selectedCountry != "") {
		var intcode = document.getElementById("intcode");
		var prefix = c[selectedCountry][1];
		intcode.innerHTML = "+" +prefix;
		
		var showCountrySmall = document.getElementById("showCountrySmall");
		showCountrySmall.innerHTML = "for "+c[selectedCountry][0];
		
		doSearch();
	} else {
		var intcode = document.getElementById("intcode");
		intcode.innerHTML = "&nbsp;&nbsp;&nbsp;&nbsp;";
		
		var detailsTable = document.getElementById("detailsTable");
		detailsTable.style.display = "none";
		var step4head = document.getElementById("step4head");
		step4head.innerHTML = "Enter number and country to view rates";
		var showDetails = document.getElementById("showDetails");
		showDetails.style.display = "none";
		var intnum = document.getElementById("intnum");
		intnum.innerHTML = "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
		
		var showCountrySmall = document.getElementById("showCountrySmall");
		showCountrySmall.innerHTML = ""
	}
}

function doSearch() {
	
	var selectedCountry = document.getElementById("country").value;
	var enteredNumberOrg = document.getElementById("number").value;
    
    if(enteredNumberOrg == "Type Skype Name or phone number...") {
        enteredNumberOrg = "";
    }
	
	var enteredNumber = "";
	for(q = 0; q < enteredNumberOrg.length; q++) {
		var character = enteredNumberOrg.charAt(q);
	 	switch(character.toLowerCase()) {
			case '0': enteredNumber += "0"; break;
			case '1': enteredNumber += "1"; break;
			case '2': enteredNumber += "2"; break;
			case '3': enteredNumber += "3"; break;
			case '4': enteredNumber += "4"; break;
			case '5': enteredNumber += "5"; break;
			case '6': enteredNumber += "6"; break;
			case '7': enteredNumber += "7"; break;
			case '8': enteredNumber += "8"; break;
			case '9': enteredNumber += "9"; break;
			case '*': enteredNumber += "_"; break;
			case 'a': case 'b': case 'c': enteredNumber += "2"; break;
			case 'd': case 'e': case 'f': enteredNumber += "3"; break;
			case 'g': case 'h': case 'i': enteredNumber += "4"; break;
			case 'j': case 'k': case 'l': enteredNumber += "5"; break;
			case 'm': case 'n': case 'o': enteredNumber += "6"; break;
			case 'p': case 'q': case 'r': case 's': enteredNumber += "7"; break;
			case 't': case 'u': case 'v': enteredNumber += "8"; break;
			case 'w': case 'x': case 'y': case 'z': enteredNumber += "9"; break;
		}
	}

	if(enteredNumber == "") {
		var intnum = document.getElementById("intnum");
		intnum.innerHTML = "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
		
		var detailsTable = document.getElementById("detailsTable");
		detailsTable.style.display = "none";
		var step4head = document.getElementById("step4head");
		step4head.innerHTML = "Enter number and country to view rates";
		var showDetails = document.getElementById("showDetails");
		showDetails.style.display = "none";
		
        var skypeoutnumber = document.getElementById("skypeoutnumber");
		skypeoutnumber.value = "";
        
		return false;
	}
	
	/* maybe, just maybe user has entered number with country code? lets remove all  + signs and check... */
	
	enteredNumber = replace(enteredNumber, '+', '');
	enteredNumber = replace(enteredNumber, ' ', '');
	enteredNumber = replace(enteredNumber, '-', '');
	enteredNumber = replace(enteredNumber, '(', '');
	enteredNumber = replace(enteredNumber, ')', '');

	var correct_prefix = ''+c[selectedCountry][1];
	var given_prefix = enteredNumber.substr(0, correct_prefix.length);
	if(correct_prefix == given_prefix) {
		enteredNumber = enteredNumber.replace(correct_prefix, '');
	}

	/* numbers dont start with zero? */
	
	if(typeof(z) != "undefined") {
        if(z[selectedCountry]) {
            var z_prefixes = new Array();
            z_prefixes = z[selectedCountry];
            nozero_number = enteredNumber;
            while(nozero_number.charAt('0') == "0") {
                nozero_number = nozero_number.substr(1, nozero_number.length);
            }
            enteredNumber = nozero_number;
            nozero_number = "0" + nozero_number;
            if(selectedCountry == "HKG") {
                nozero_number = "0" + nozero_number;
            }
            for(i = 0; i <= nozero_number.length; i++) {
			    check_part = nozero_number.substr(0, i);
			    if(z_prefixes.inArray(check_part)) {
                    enteredNumber = nozero_number;
			    }
            }
        } else {
            while(enteredNumber.charAt('0') == "0") {
                enteredNumber = enteredNumber.substr(1, enteredNumber.length);
            }
        }
	}
	
	/* special cases */
	
    if(selectedCountry == "BRA" && enteredNumber.length >= 11) {
        firsttwo = enteredNumber.substr(0, 2);
        brazilian_carriers = Array('21','23','31','14','15','41','12','28');
        if(brazilian_carriers.inArray(firsttwo)) {
            enteredNumber = enteredNumber.substr(2, enteredNumber.length);
        }
    }
	
	if(correct_prefix == "262" || correct_prefix == "590" || correct_prefix == "" || correct_prefix == "596") {
		step2prefix = enteredNumber.substr(0, 3);
		if((correct_prefix == "262" && step2prefix != "692") || (correct_prefix == "590" && step2prefix != "690") || (correct_prefix == "594" && step2prefix != "694") || (correct_prefix == "596" && step2prefix != "696")) {
			enteredNumber = correct_prefix+enteredNumber;
		}
	}
	
	/* prefixes & blocked routes */
	
	if(selectedCountry != "") {
		var intcode = document.getElementById("intcode");
		var prefix = c[selectedCountry][1];
		intcode.innerHTML = "+" + prefix;
		var intnum = document.getElementById("intnum");
		if(enteredNumber.length > 0) {
			intnum.innerHTML = enteredNumber;
		} else {
			intnum.innerHTML = "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
		}
		
		var wholenumber = prefix + enteredNumber;
		for(i = 0; i <= wholenumber.length; i++) {
			check_part = wholenumber.substr(0, i);
			if(blocked_routes.inArray(check_part)) {
				matched_part = null;
				price = null;
				var blockedroute = true;
			} else {
				if(check_part.length > 7) {
					check_part = "x"+check_part
				}
				if(c[selectedCountry][2][check_part]) {
					var matched_part = check_part;
					var price = c[selectedCountry][2][check_part];
				}
			}
		}
		
		if(matched_part && price) {
			var step4head = document.getElementById("step4head");
			step4head.innerHTML = "Rates for dialing this number";
			var showDetails = document.getElementById("showDetails");
			showDetails.style.display = "none";
			var detailsTable = document.getElementById("detailsTable");
			detailsTable.style.display = "block";
			
			var showPrice = document.getElementById("showPrice");
			showPrice.innerHTML = "&euro; "+price;

			var skypeoutnumber = document.getElementById("skypeoutnumber");
			skypeoutnumber.value = wholenumber;
		} else {
			var detailsTable = document.getElementById("detailsTable");
			detailsTable.style.display = "none";
			var showDetails = document.getElementById("showDetails");
			if(!blockedroute) {
				showDetails.innerHTML = "<p class=\"offset\"><big>The number you have entered is incorrect.</big></p>";
			} else {
				showDetails.innerHTML = "<p class=\"offset\"><big>The number you have entered is not supported by Skype.</big></p>";
			}
			showDetails.style.display = "block";
			
			var skypeoutnumber = document.getElementById("skypeoutnumber");
			skypeoutnumber.value = "#";
		}
	} else {
	}
}